Package com.google.android.exoplayer2.extractor.avi

## Class AviExtractor

- java.lang.Object
- - com.google.android.exoplayer2.extractor.avi.AviExtractor

- All Implemented Interfaces:
    `Extractor`

      public final class AviExtractor
      extends Object
      implements Extractor

  Extracts data from the AVI container format.

  Spec: https://docs.microsoft.com/en-us/windows/win32/directshow/avi-riff-file-reference.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.google.android.exoplayer2.extractor.Extractor

      `Extractor.ReadResult`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `FOURCC_auds` |
    `static int` | `FOURCC_AVI_` |
    `static int` | `FOURCC_avih` |
    `static int` | `FOURCC_hdrl` |
    `static int` | `FOURCC_idx1` |
    `static int` | `FOURCC_JUNK` |
    `static int` | `FOURCC_LIST` |
    `static int` | `FOURCC_movi` |
    `static int` | `FOURCC_RIFF` |
    `static int` | `FOURCC_strf` |
    `static int` | `FOURCC_strh` |
    `static int` | `FOURCC_strl` |
    `static int` | `FOURCC_strn` |
    `static int` | `FOURCC_txts` |
    `static int` | `FOURCC_vids` |

    - ### Fields inherited from interface com.google.android.exoplayer2.extractor.Extractor

      `RESULT_CONTINUE, RESULT_END_OF_INPUT, RESULT_SEEK`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AviExtractor()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `init​(ExtractorOutput output)` | Initializes the extractor with an `ExtractorOutput`.
    `int` | `read​(ExtractorInput input, PositionHolder seekPosition)` | Extracts data read from a provided `ExtractorInput`.
    `void` | `release()` | Releases all kept resources.
    `void` | `seek​(long position, long timeUs)` | Notifies the extractor that a seek has occurred.
    `boolean` | `sniff​(ExtractorInput input)` | Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FOURCC_RIFF

          public static final int FOURCC_RIFF

      See Also:
        Constant Field Values

    - #### FOURCC_AVI_

          public static final int FOURCC_AVI_

      See Also:
        Constant Field Values

    - #### FOURCC_LIST

          public static final int FOURCC_LIST

      See Also:
        Constant Field Values

    - #### FOURCC_avih

          public static final int FOURCC_avih

      See Also:
        Constant Field Values

    - #### FOURCC_hdrl

          public static final int FOURCC_hdrl

      See Also:
        Constant Field Values

    - #### FOURCC_strl

          public static final int FOURCC_strl

      See Also:
        Constant Field Values

    - #### FOURCC_movi

          public static final int FOURCC_movi

      See Also:
        Constant Field Values

    - #### FOURCC_idx1

          public static final int FOURCC_idx1

      See Also:
        Constant Field Values

    - #### FOURCC_JUNK

          public static final int FOURCC_JUNK

      See Also:
        Constant Field Values

    - #### FOURCC_strf

          public static final int FOURCC_strf

      See Also:
        Constant Field Values

    - #### FOURCC_strn

          public static final int FOURCC_strn

      See Also:
        Constant Field Values

    - #### FOURCC_strh

          public static final int FOURCC_strh

      See Also:
        Constant Field Values

    - #### FOURCC_auds

          public static final int FOURCC_auds

      See Also:
        Constant Field Values

    - #### FOURCC_txts

          public static final int FOURCC_txts

      See Also:
        Constant Field Values

    - #### FOURCC_vids

          public static final int FOURCC_vids

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AviExtractor

          public AviExtractor()

  - ### Method Detail

    - #### init

          public void init​(ExtractorOutput output)

      Description copied from interface: `Extractor`
      Initializes the extractor with an `ExtractorOutput`. Called at most once.
      Specified by:
        `init` in interface `Extractor`
      Parameters:
        `output` - An `ExtractorOutput` to receive extracted data.

    - #### sniff

          public boolean sniff​(ExtractorInput input)
                        throws IOException

      Description copied from interface: `Extractor`
      Returns whether this extractor can extract samples from the `ExtractorInput`, which must provide data from the start of the stream.

      If `true` is returned, the `input`'s reading position may have been modified. Otherwise, only its peek position may have been modified.

      Specified by:
        `sniff` in interface `Extractor`
      Parameters:
        `input` - The `ExtractorInput` from which data should be peeked/read.
      Returns:
        Whether this extractor can read the provided input.
      Throws:
        `IOException` - If an error occurred reading from the input.

    - #### read

          public int read​(ExtractorInput input,
                          PositionHolder seekPosition)
                   throws IOException

      Description copied from interface: `Extractor`
      Extracts data read from a provided `ExtractorInput`. Must not be called before `Extractor.init(ExtractorOutput)`.

      A single call to this method will block until some progress has been made, but will not block for longer than this. Hence each call will consume only a small amount of input data.

      In the common case, `Extractor.RESULT_CONTINUE` is returned to indicate that the `ExtractorInput` passed to the next read is required to provide data continuing from the position in the stream reached by the returning call. If the extractor requires data to be provided from a different position, then that position is set in `seekPosition` and `Extractor.RESULT_SEEK` is returned. If the extractor reached the end of the data provided by the `ExtractorInput`, then `Extractor.RESULT_END_OF_INPUT` is returned.

      When this method throws an `IOException`, extraction may continue by providing an `ExtractorInput` with an unchanged `read position` to a subsequent call to this method.

      Specified by:
        `read` in interface `Extractor`
      Parameters:
        `input` - The `ExtractorInput` from which data should be read.
        `seekPosition` - If `Extractor.RESULT_SEEK` is returned, this holder is updated to hold the position of the required data.
      Returns:
        One of the `RESULT_` values defined in this interface.
      Throws:
        `IOException` - If an error occurred reading from or parsing the input.

    - #### seek

          public void seek​(long position,
                           long timeUs)

      Description copied from interface: `Extractor`
      Notifies the extractor that a seek has occurred.

      Following a call to this method, the `ExtractorInput` passed to the next invocation of `Extractor.read(ExtractorInput, PositionHolder)` is required to provide data starting from `position` in the stream. Valid random access positions are the start of the stream and positions that can be obtained from any `SeekMap` passed to the `ExtractorOutput`.

      Specified by:
        `seek` in interface `Extractor`
      Parameters:
        `position` - The byte offset in the stream from which data will be provided.
        `timeUs` - The seek time in microseconds.

    - #### release

          public void release()

      Description copied from interface: `Extractor`
      Releases all kept resources.
      Specified by:
        `release` in interface `Extractor`